<?php	

/**
* @package manifest for this file
* @version 0.1
* @ts 2014-04-16 14:37
* @author http://andrzej.borowicz.info/smf
* @copyright http://andrzej.borowicz.info/smf
* @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
*/

if (!defined('SMF')) die(' ups, not found 404 ');

function abSearchStat()
{
	isAllowedTo('admin_forum');
	global $context, $txt;
	if (loadLanguage('absearchstat') == false) loadLanguage('absearchstat', 'english');

	$context[$context['admin_menu_name']]['tab_data']['title'] = $txt['abSearchStat'];
	$context[$context['admin_menu_name']]['tab_data']['description'] = $txt['abSearchStat_description'];
	
	$sa = 'config';

	if ( isset($_REQUEST['sa']) ) 
	{
		$sa = trim($_REQUEST['sa']);
	}

	switch($sa)
	{
		default:
		case '':
		case 'config':
			abSearchStat_config();
			break;
		case 'last':
			$context['settings_title'] = $txt['abSearchStat_last'];
			$context['sub_template'] = 'content';
			abSearchStat_dataLast();
			break;
		case 'top':
			$context['settings_title'] = $txt['abSearchStat_top'];
			$context['sub_template'] = 'content';
			abSearchStat_dataTop();
			break;
		case 'users':
			if ( isset($_REQUEST['ssuid']) && (int)$_REQUEST['ssuid']>0 )
			{
				$context['settings_title'] = $txt['abSearchStat_users'];
				$context['sub_template'] = 'content';
				abSearchStat_dataUserDetails();			
			
			}
			else {
				$context['settings_title'] = $txt['abSearchStat_user'];
				$context['sub_template'] = 'content';
				abSearchStat_dataUsers();			
			}
			break;
	}

}

function abSearchStat_add2menu(&$admin_areas=false) 
{
	global $txt;

	if (loadLanguage('absearchstat') == false) loadLanguage('absearchstat', 'english');
	
	$admin_areas['maintenance']['areas']['abSearchStat'] = array(
		'label' => $txt['abSearchStat'],
		'file' => 'Subs-absearchstat.php',
		'function' => 'abSearchStat',
		'icon' => 'server.gif',
		'subsections' => array(
			'config' 	=> array($txt['abSearchStat'], 'admin_forum'),
			'last' 		=> array($txt['abSearchStat_last'], 'admin_forum'),
			'top' 		=> array($txt['abSearchStat_top'], 'admin_forum'),
			'users' 	=> array($txt['abSearchStat_users'], 'admin_forum'),
		),
	);
	
	return $admin_areas;
}

function abSearchStat_collect() 
{
	global $modSettings;
	
	if ( $modSettings['abSearchStat_enable'] )
	{
		global $context, $smcFunc;
		if ( isset($context['search_params']['search']) && !empty($context['search_params']['search']) )
		{
			$smcFunc['db_insert']( 'ignore' ,
				'{db_prefix}log_search_words',
				array(
					's_id' => 'string', 
					's_date' => 'string', 
					's_user' => 'int',
					's_data' => 'string',
				),
				array(
					$context['session_id'], 
					date("Y-m-d H:i:s"), 
					$context['user']['id'],
					$context['search_params']['search']
				),
				array()
			);
		}
	}
	
	if ( $modSettings['abSearchStat_cloud'] )
	{
		//@2do
	}
}

function abSearchStat_config()
{
	global $txt, $scripturl, $context, $modSettings, $sourcedir;
	if (loadLanguage('absearchstat') == false) loadLanguage('absearchstat', 'english');

	$context['settings_title'] = $txt['abSearchStat'].' - '.$txt['abSearchStat_config'];
	$context['post_url'] = $scripturl . '?action=admin;area=abSearchStat;sa=save';
	$context['sub_template'] = 'show_settings';
	
	//$context['settings_insert_below'] = '';

	require_once($sourcedir . '/ManageServer.php'); // >> Sources/ManageServer.php >> function prepareDBSettingContext
	
		
	$config_vars = array( 
		// On or off?
		array('check', 'abSearchStat_enable', 
				'label' => $txt['abSearchStat_enable'],
				//'',
				//'preinput' => 'abcounter_enable',
				//'postinput' => 'abcounter_enable',
				//'var_message' => 'var_message' 
				),
		//array('check', 'abSearchStat_cloud', 'label' => $txt['abSearchStat_cloud']), //@2do
		//array('text', 'abSearchStat_custom', 'label' => $txt['abSearchStat_custom']), //@2do
	);
	
	// Saving?
	if ( isset($_GET['sa']) && $_GET['sa'] == 'save' )
	{
		checkSession();
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=abSearchStat;sa=config');
	}

	prepareDBSettingContext($config_vars);
}

function abSearchStat_dataTotal() 
{
	$q = 'SELECT 
w.s_date AS stime, 
w.s_data AS ssearch, w.s_user AS user, m.member_name AS userName
FROM {db_prefix}log_search_words AS w
LEFT JOiN {db_prefix}members AS m ON m.id_member = w.s_user
ORDER BY s_uid DESC
LIMIT 0,50';
	global $html;
	$html = abSearchStat_load($q);
}

function abSearchStat_dataTop() 
{
	$q = 'SELECT COUNT( w.s_uid ) AS cnt, w.s_data AS ssearch
FROM {db_prefix}log_search_words AS w
GROUP BY w.s_data
ORDER BY cnt DESC
LIMIT 0 , 10';
	global $html;
	$html = abSearchStat_load($q);
}

function abSearchStat_dataUserDetails() 
{
	$q = 'SELECT 
w.s_date AS stime, 
w.s_data AS ssearch, w.s_user AS user, m.member_name AS userName
FROM {db_prefix}log_search_words AS w
LEFT JOiN {db_prefix}members AS m ON m.id_member = w.s_user
WHERE w.s_user = "'.$_GET['ssuid'].'"
ORDER BY s_uid DESC
LIMIT 0,50';
	global $html;
	$html = abSearchStat_load($q);
}

function abSearchStat_dataUsers() 
{
	$q = 'SELECT 
COUNT( w.s_uid ) AS cnt, w.s_user AS user, m.member_name AS userName
FROM {db_prefix}log_search_words AS w
LEFT JOiN {db_prefix}members AS m ON m.id_member = w.s_user
GROUP BY w.s_user
ORDER BY cnt DESC
LIMIT 0,50';
	global $html;
	$html = abSearchStat_load($q);
}

function abSearchStat_dataLast() 
{
	$q = 'SELECT 
w.s_date AS stime, 
w.s_data AS ssearch, w.s_user AS user, m.member_name AS userName
FROM {db_prefix}log_search_words AS w
LEFT JOiN {db_prefix}members AS m ON m.id_member = w.s_user
ORDER BY s_uid DESC
LIMIT 0,50';
	global $html;
	$html = abSearchStat_load($q);
}

function abSearchStat_load($q)
{
	global $smcFunc, $boardurl, $boardurl, $txt;
	$result = $smcFunc['db_query']('', $q, array());
	
	$html = '';
	
	$_i = 0;
	$bg = '';
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		if($_i == 0)
		{
			$head = '<tr class="catbg" style="padding: 5px 0px 5px 20px;">';
			
			if ( isset($row['cnt']) ) 	$head.= '<td style="width: 30px;">&nbsp;'.$txt['abSearchStat_cnt'].'</td>';

			if ( isset($row['stime']) )	$head.= '<td style="width: 150px;">&nbsp;'.$txt['abSearchStat_stime'].'</td>';

			if ( isset($row['d']) ) 	$head.= '<td>&nbsp;'.$txt['abSearchStat_d'].'</td>';

			if ( isset($row['t']) ) 	$head.= '<td>&nbsp;'.$txt['abSearchStat_t'].'</td>';

			if ( isset($row['user']) )	$head.= '<td>&nbsp;'.$txt['abSearchStat_user'].'</td>';

			if ( isset($row['ssearch']) ) $head.= '<td>&nbsp;'.$txt['abSearchStat_ssearch'].'</td>';
			
			$head.= '</tr>';
		}
		
		$_i++;
		($_i%2) ? $bg = '2' : $bg = '';
		$html.= "\r\n".'<tr class="windowbg'.$bg.'" style="padding: 10px 15px 20px 15px;">';
		
		if ( isset($row['cnt']) ) 	$html.= '<td>&nbsp;'.$row['cnt'].'</td>';

		if ( isset($row['stime']) )	$html.= '<td>&nbsp;'.$row['stime'].'</td>';

		if ( isset($row['d']) ) 	$html.= '<td>&nbsp;'.$row['d'].'</td>';

		if ( isset($row['t']) ) 	$html.= '<td>&nbsp;'.$row['t'].'</td>';

		if ( isset($row['user']) ) 
		{
			$html.= '<td>&nbsp;<a href="'.$boardurl.'?action=admin;area=abSearchStat;sa=users;ssuid='.$row['user'].'">'.$row['userName'].'</a></td>';
		}

		if ( isset($row['ssearch']) ) $html.= '<td><a href="'.$boardurl.'?action=search2&search='.$row['ssearch'].'">'.$row['ssearch'].'</a></td>';
		
		$html.= '</tr>';
	}
	
	return $head.$html;
	
}

function template_content() 
{
	global $html, $context;
	echo '
	<div class="cat_bar">
		<h3 class="catbg">
			'.$context['settings_title'].'
		</h3>
	</div>
	<table class="table_grid" id="error_log" cellspacing="0" cellpadding="0" border="0">
		<tbody>
'.$html.'
		</tbody>
	</table>
	';
}


?>