<?php	

/**
* @package manifest for this file
* @version 0.1
* @ts 2014-04-16 14:37
* @author http://andrzej.borowicz.info/smf
* @copyright http://andrzej.borowicz.info/smf
* @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
*/

// If SSI.php is in the same place as this file, and SMF isn't defined...
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');

// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot uninstall - please verify your files.');

global $smcFunc, $db_prefix, $sourcedir;


$tableWords = array(
	'columns' => array(
		array(
			'name' => 's_uid',
			'type' => 'int',
			'size' => 10,
			'unsigned' => true,
			'auto' => true,
		),
		array(
			'name' => 's_id',
			'type' => 'char',
			'size' => 32,
		),
		array(
			'name' => 's_date',
			'type' => 'timestamp',
			'default' => '0000-00-00 00:00:00',
		),
		array(
			'name' => 's_user',
			'type' => 'int',
			'size' => 10,
			'unsigned' => true,
		),
		array(
			'name' => 's_data',
			'type' => 'text',
		),
	),
	'indexes' => array(
		array(
			'type' => 'primary',
			'columns' => array('s_uid'),
		),
	),
);

$tableLinks = array(
	'columns' => array(
		array(
			'name' => 'l_uid',
			'type' => 'int',
			'size' => 10,
			'unsigned' => true,
			'auto' => true,
		),
		array(
			'name' => 's_str',
			'type' => 'text',
		),
		array(
			'name' => 's_data',
			'type' => 'text',
		),
	),
	'indexes' => array(
		array(
			'type' => 'primary',
			'columns' => array('l_uid'),
		),
	),
);

$smcFunc['db_create_table']('{db_prefix}log_search_words', $tableWords['columns'], $tableWords['indexes']);
$smcFunc['db_create_table']('{db_prefix}log_search_words_links', $tableLinks['columns'], $tableLinks['indexes']);

$abSearchStat = array(
	'abSearchStat' => 1,
	'abSearchStat_enable' => 1,
	'abSearchStat_cloud' => 1,
);

updateSettings($abSearchStat);

add_integration_function('integrate_pre_include', '$sourcedir/Subs-absearchstat.php');
add_integration_function('integrate_admin_areas', 'abSearchStat_add2menu', true);

if (SMF == 'SSI')
echo 'Database adaptation successful!';

?>